Complete new entrypoint script.

This commit is contained in:
Llewellyn van der Merwe 2024-06-11 16:27:52 +02:00
parent 17644fc837
commit 96648d4eb0
Signed by: Llewellyn
GPG Key ID: A9201372263741E7
3 changed files with 350 additions and 346 deletions

View File

@ -8,68 +8,7 @@ We have our own readme document, that replace the Joomla official readme, here i
### Changes to entrypoint.sh
We have added some code to the entrypoint, the updated version is here in this repo, and is called [joomla-entrypoint.sh](https://git.vdm.dev/octoleo/octojdoc/src/joomla-entrypoint.sh), the code is marked with `####### OCTOLEO ##` and also listed below.
The Extra Functions
```
validate_url() {
if [[ $1 =~ ^http(s)?://[a-zA-Z0-9.-]+\.[a-zA-Z]{2,}(/.*)?$ ]]; then
return 0
else
return 1
fi
}
```
The Extra Install actions
```
# Install any extensions found in the extensions urls env
if [[ -n "${JOOMLA_EXTENSIONS_URLS}" && "${#JOOMLA_EXTENSIONS_URLS}" -gt 2 ]]; then
IFS=';' read -ra ADDR <<< "$JOOMLA_EXTENSIONS_URLS"
for extension_url in "${ADDR[@]}"; do
# Validate each URL
if validate_url "$extension_url"; then
# Try to install the Joomla extension from the URL
if php cli/joomla.php extension:install --url "${extension_url}"; then
echo >&2 "Successfully installed ${extension_url}"
else
echo >&2 "Failed to install ${extension_url}"
fi
else
echo >&2 "Invalid URL: ${extension_url}"
fi
done
fi
# Extract the hostname and port from JOOMLA_SMTP_HOST if it includes ':'
if [[ -n "${JOOMLA_SMTP_HOST}" && "${JOOMLA_SMTP_HOST}" == *:* ]]; then
IFS=':' read -r hostname port <<< "${JOOMLA_SMTP_HOST}"
JOOMLA_SMTP_HOST=$hostname
JOOMLA_SMTP_HOST_PORT=$port
fi
# Update configuration.php if JOOMLA_SMTP_HOST is set and longer than 2 characters
if [[ -n "${JOOMLA_SMTP_HOST}" && "${#JOOMLA_SMTP_HOST}" -gt 2 ]]; then
chmod +w configuration.php
sed -i "s/public \$mailer = 'mail';/public \$mailer = 'smtp';/g" configuration.php
sed -i "s/public \$smtphost = 'localhost';/public \$smtphost = '${JOOMLA_SMTP_HOST}';/g" configuration.php
fi
# Update the SMTP port in configuration.php if JOOMLA_SMTP_HOST_PORT is set
if [[ -n "${JOOMLA_SMTP_HOST_PORT}" ]]; then
sed -i "s/public \$smtpport = 25;/public \$smtpport = ${JOOMLA_SMTP_HOST_PORT};/g" configuration.php
fi
# fix the ownership
if [ "$uid" = '0' ] && [ "$(stat -c '%u:%g' configuration.php)" != "$user:$group" ]; then
# Set configuration to correct owner
if ! chown -R "$user:$group" .; then
echo >&2
echo >&2 "Error: Ownership of configuration.php failed to be corrected."
fi
# Set configuration to correct permissions
if ! chmod 444 configuration.php; then
echo >&2
echo >&2 "Error: Permissions of configuration.php failed to be corrected."
fi
fi
```
We have completely refactored the entrypoint for a cleaner and stable approach.
### License

View File

@ -1,10 +1,170 @@
#!/bin/bash
set -e
# Load database password from file if specified
if [ -n "$JOOMLA_DB_PASSWORD_FILE" ] && [ -f "$JOOMLA_DB_PASSWORD_FILE" ]; then
JOOMLA_DB_PASSWORD=$(cat "$JOOMLA_DB_PASSWORD_FILE")
fi
# Function to log messages
joomla_log() {
local msg="$1"
echo >&2 " $msg"
}
# Function to log info messages
joomla_log_info() {
local msg="$1"
echo >&2 "[INFO] $msg"
}
# Function to log warning messages
joomla_log_warning() {
local msg="$1"
echo >&2 "[WARNING] $msg"
}
# Function to log error messages
joomla_log_error() {
local msg="$1"
echo >&2 "[ERROR] $msg"
}
# Function to set a line
joomla_line() {
echo >&2 "========================================================================"
}
# Function to set a line at end
joomla_line_start() {
joomla_line
echo >&2
}
# Function to set a line at end
joomla_line_end() {
echo >&2
joomla_line
}
# Function to give final success message (1)
joomla_success() {
joomla_log "This server is now configured to run Joomla!"
}
# Function to give final success message (2)
joomla_success_need_db() {
joomla_success
echo >&2
joomla_log " NOTE: You will need your database server address, database name,"
joomla_log " and database user credentials to install Joomla."
}
# Function to validate URLs
joomla_validate_url() {
if [[ $1 =~ ^http(s)?://[a-zA-Z0-9.-]+\.[a-zA-Z]{2,}(/.*)?$ ]]; then
return 0
else
return 1
fi
}
# Function to validate paths
joomla_validate_path() {
if [[ -f $1 ]]; then
return 0
else
return 1
fi
}
# Function to split values by semicolon
joomla_split_values() {
local input=$1
local -n arr=$2
IFS=';' read -ra arr <<< "$input"
}
# Function to install extension from URL
joomla_install_from_url() {
local url=$1
if joomla_validate_url "$url"; then
if php cli/joomla.php extension:install --url "$url" --no-interaction; then
joomla_log_info "Successfully installed $url"
else
joomla_log_error "Failed to install $url"
fi
else
joomla_log_error "Invalid URL: $url"
fi
}
# Function to install extension from path
joomla_install_from_path() {
local path=$1
if joomla_validate_path "$path"; then
if php cli/joomla.php extension:install --path "$path" --no-interaction; then
joomla_log_info "Successfully installed $path"
else
joomla_log_error "Failed to install $path"
fi
else
joomla_log_error "Invalid Path: $path"
fi
}
# Function to validate necessary environment variables
joomla_validate_vars() {
# Basic email regex for validation
local email_regex="^[a-zA-Z0-9._%+-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,}$"
# Check if JOOMLA_SITE_NAME is longer than 2 characters
if [[ "${#JOOMLA_SITE_NAME}" -le 2 ]]; then
joomla_log_error "JOOMLA_SITE_NAME must be longer than 2 characters!"
return 1
fi
# Check if JOOMLA_ADMIN_USER is longer than 2 characters
if [[ "${#JOOMLA_ADMIN_USER}" -le 2 ]]; then
joomla_log_error "JOOMLA_ADMIN_USER must be longer than 2 characters!"
return 1
fi
# Check if JOOMLA_ADMIN_USERNAME has no spaces, and is only alphabetical
if [[ "${JOOMLA_ADMIN_USERNAME}" =~ [^a-zA-Z] ]]; then
joomla_log_error "JOOMLA_ADMIN_USERNAME must contain no spaces and be only alphabetical!"
return 1
fi
# Check if JOOMLA_ADMIN_PASSWORD is longer than 12 characters
if [[ "${#JOOMLA_ADMIN_PASSWORD}" -le 12 ]]; then
joomla_log_error "JOOMLA_ADMIN_PASSWORD must be longer than 12 characters!"
return 1
fi
# Check if JOOMLA_ADMIN_EMAIL is a valid email
if [[ ! "${JOOMLA_ADMIN_EMAIL}" =~ $email_regex ]]; then
joomla_log_error "JOOMLA_ADMIN_EMAIL must be a valid email address!"
return 1
fi
return 0
}
# Function to check if auto deploy can be done
joomla_can_auto_deploy() {
if [[ -n "${JOOMLA_SITE_NAME}" && -n "${JOOMLA_ADMIN_USER}" &&
-n "${JOOMLA_ADMIN_USERNAME}" && -n "${JOOMLA_ADMIN_PASSWORD}" &&
-n "${JOOMLA_ADMIN_EMAIL}" ]]; then
if joomla_validate_vars; then
return 0
fi
fi
return 1
}
if [[ "$1" == apache2* ]] || [ "$1" == php-fpm ]; then
uid="$(id -u)"
gid="$(id -g)"
@ -15,9 +175,8 @@ if [[ "$1" == apache2* ]] || [ "$1" == php-fpm ]; then
group="${APACHE_RUN_GROUP:-www-data}"
# strip off any '#' symbol ('#1000' is valid syntax for Apache)
pound='#'
user="${user#$pound}"
group="${group#$pound}"
user="${user#'#'}"
group="${group#'#'}"
# set user if not exist
if ! id "$user" &>/dev/null; then
@ -43,20 +202,24 @@ if [[ "$1" == apache2* ]] || [ "$1" == php-fpm ]; then
group="$gid"
fi
# start Joomla message block
joomla_line_start
if [ -n "$MYSQL_PORT_3306_TCP" ]; then
if [ -z "$JOOMLA_DB_HOST" ]; then
JOOMLA_DB_HOST='mysql'
else
echo >&2 "warning: both JOOMLA_DB_HOST and MYSQL_PORT_3306_TCP found"
echo >&2 " Connecting to JOOMLA_DB_HOST ($JOOMLA_DB_HOST)"
echo >&2 " instead of the linked mysql container"
joomla_log_warning "both JOOMLA_DB_HOST and MYSQL_PORT_3306_TCP found"
joomla_log "Connecting to JOOMLA_DB_HOST ($JOOMLA_DB_HOST)"
joomla_log "instead of the linked mysql container"
fi
fi
if [ -z "$JOOMLA_DB_HOST" ]; then
echo >&2 "error: missing JOOMLA_DB_HOST and MYSQL_PORT_3306_TCP environment variables"
echo >&2 " Did you forget to --link some_mysql_container:mysql or set an external db"
echo >&2 " with -e JOOMLA_DB_HOST=hostname:port?"
joomla_log_error "Missing JOOMLA_DB_HOST and MYSQL_PORT_3306_TCP environment variables."
joomla_log "Did you forget to --link some_mysql_container:mysql or set an external db"
joomla_log "with -e JOOMLA_DB_HOST=hostname:port?"
# end Joomla message block
joomla_line_end
exit 1
fi
@ -68,10 +231,9 @@ if [[ "$1" == apache2* ]] || [ "$1" == php-fpm ]; then
: "${JOOMLA_DB_NAME:=joomla}"
if [ -z "$JOOMLA_DB_PASSWORD" ] && [ "$JOOMLA_DB_PASSWORD_ALLOW_EMPTY" != 'yes' ]; then
echo >&2 "error: missing required JOOMLA_DB_PASSWORD environment variable"
echo >&2 " Did you forget to -e JOOMLA_DB_PASSWORD=... ?"
echo >&2
echo >&2 " (Also of interest might be JOOMLA_DB_USER and JOOMLA_DB_NAME.)"
joomla_log_error "Missing required JOOMLA_DB_PASSWORD environment variable. Did you forget to -e JOOMLA_DB_PASSWORD=... ?"
# end Joomla message block
joomla_line_end
exit 1
fi
@ -81,17 +243,16 @@ if [[ "$1" == apache2* ]] || [ "$1" == php-fpm ]; then
chown "$user:$group" .
fi
echo >&2 "Joomla not found in $PWD - copying now..."
joomla_log_info "Joomla not found in $PWD - copying now..."
if [ "$(ls -A)" ]; then
echo >&2 "WARNING: $PWD is not empty - press Ctrl+C now if this is an error!"
joomla_log_warning "$PWD is not empty - press Ctrl+C now if this is an error!"
(
set -x
ls -A
sleep 10
)
fi
# use full commands
# for clearer intent
sourceTarArgs=(
--create
--file -
@ -112,85 +273,18 @@ if [[ "$1" == apache2* ]] || [ "$1" == php-fpm ]; then
if [ ! -e .htaccess ]; then
# NOTE: The "Indexes" option is disabled in the php:apache base image so remove it as we enable .htaccess
sed -r 's/^(Options -Indexes.*)$/#\1/' htaccess.txt >.htaccess
chown "$user":"$group" .htaccess
sed -r 's/^(Options -Indexes.*)$/#\1/' htaccess.txt > .htaccess
chown "$user:$group" .htaccess
fi
echo >&2 "Complete! Joomla has been successfully copied to $PWD"
joomla_log "Complete! Joomla has been successfully copied to $PWD"
fi
# Ensure the MySQL Database is created
php /makedb.php "$JOOMLA_DB_HOST" "$JOOMLA_DB_USER" "$JOOMLA_DB_PASSWORD" "$JOOMLA_DB_NAME" "${JOOMLA_DB_TYPE:-mysqli}"
# Basic email regex for validation
email_regex="^[a-zA-Z0-9._%+-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,}$"
# Function to validate environment variables
validate_vars() {
# Check if JOOMLA_SITE_NAME is longer than 2 characters
if [[ "${#JOOMLA_SITE_NAME}" -le 2 ]]; then
echo >&2 "Error: JOOMLA_SITE_NAME must be longer than 2 characters!"
return 1
fi
# Check if JOOMLA_ADMIN_USER is longer than 2 characters
if [[ "${#JOOMLA_ADMIN_USER}" -le 2 ]]; then
echo >&2 "Error: JOOMLA_ADMIN_USER must be longer than 2 characters!"
return 1
fi
# Check if JOOMLA_ADMIN_USERNAME has no spaces, and is only alphabetical
if [[ "${JOOMLA_ADMIN_USERNAME}" =~ [^a-zA-Z] ]]; then
echo >&2 "Error: JOOMLA_ADMIN_USERNAME must contain no spaces and be only alphabetical!"
return 1
fi
# Check if JOOMLA_ADMIN_PASSWORD is longer than 12 characters
if [[ "${#JOOMLA_ADMIN_PASSWORD}" -le 12 ]]; then
echo >&2 "Error: JOOMLA_ADMIN_PASSWORD must be longer than 12 characters!"
return 1
fi
# Check if JOOMLA_ADMIN_EMAIL is a valid email
if [[ ! "${JOOMLA_ADMIN_EMAIL}" =~ $email_regex ]]; then
echo >&2 "Error: JOOMLA_ADMIN_EMAIL must be a valid email address!"
return 1
fi
# If all checks passed, return 0
return 0
}
# Function to check that auto deploy can be done
can_auto_deploy() {
# Check if all NEEDED variables exist
if [[ -n "${JOOMLA_SITE_NAME}" && -n "${JOOMLA_ADMIN_USER}" &&
-n "${JOOMLA_ADMIN_USERNAME}" && -n "${JOOMLA_ADMIN_PASSWORD}" &&
-n "${JOOMLA_ADMIN_EMAIL}" ]]; then
# All variables exist. Now validate them.
if validate_vars; then
# If all checks passed, return 0
return 0
fi
fi
# If any needed variables does not exist fail, return 1
return 1
}
############################ OCTOLEO ## EXTRA FUNCTIONS ########################################################
validate_url() {
if [[ $1 =~ ^http(s)?://[a-zA-Z0-9.-]+\.[a-zA-Z]{2,}(/.*)?$ ]]; then
return 0
else
return 1
fi
}
################################################################################################################
# if the directory exists and we can auto deploy
if [ -d installation ] && [ -e installation/joomla.php ] && can_auto_deploy; then
# use full commands
# for clearer intent
# if the (installation) directory exists and we can auto deploy
if [ -d installation ] && [ -e installation/joomla.php ] && joomla_can_auto_deploy; then
installJoomlaArgs=(
--site-name="${JOOMLA_SITE_NAME}"
--admin-email="${JOOMLA_ADMIN_EMAIL}"
@ -208,84 +302,59 @@ if [[ "$1" == apache2* ]] || [ "$1" == php-fpm ]; then
# Run the auto deploy (install)
if php installation/joomla.php install "${installJoomlaArgs[@]}"; then
# The PHP command succeeded (so we remove the installation folder)
rm -rf installation
echo >&2 "========================================================================"
echo >&2
echo >&2 "This server is now configured to run Joomla!"
############################ OCTOLEO ## EXTRA INSTALL ACTIONS ###############################################
joomla_success
# Install any extensions found in the extensions urls env
if [[ -n "${JOOMLA_EXTENSIONS_URLS}" && "${#JOOMLA_EXTENSIONS_URLS}" -gt 2 ]]; then
IFS=';' read -ra ADDR <<< "$JOOMLA_EXTENSIONS_URLS"
for extension_url in "${ADDR[@]}"; do
# Validate each URL
if validate_url "$extension_url"; then
# Try to install the Joomla extension from the URL
if php cli/joomla.php extension:install --url "${extension_url}"; then
echo >&2 "Successfully installed ${extension_url}"
else
echo >&2 "Failed to install ${extension_url}"
fi
else
echo >&2 "Invalid URL: ${extension_url}"
fi
joomla_split_values "$JOOMLA_EXTENSIONS_URLS" JURLS
for extension_url in "${JURLS[@]}"; do
joomla_install_from_url "$extension_url"
done
fi
# Extract the hostname and port from JOOMLA_SMTP_HOST if it includes ':'
# Install any extensions found in the extensions paths env
if [[ -n "${JOOMLA_EXTENSIONS_PATHS}" && "${#JOOMLA_EXTENSIONS_PATHS}" -gt 2 ]]; then
joomla_split_values "$JOOMLA_EXTENSIONS_PATHS" JPATHS
for extension_path in "${JPATHS[@]}"; do
joomla_install_from_path "$extension_path"
done
fi
if [[ -n "${JOOMLA_SMTP_HOST}" && "${JOOMLA_SMTP_HOST}" == *:* ]]; then
IFS=':' read -r hostname port <<< "${JOOMLA_SMTP_HOST}"
JOOMLA_SMTP_HOST=$hostname
JOOMLA_SMTP_HOST_PORT=$port
fi
# Update configuration.php if JOOMLA_SMTP_HOST is set and longer than 2 characters
if [[ -n "${JOOMLA_SMTP_HOST}" && "${#JOOMLA_SMTP_HOST}" -gt 2 ]]; then
chmod +w configuration.php
sed -i "s/public \$mailer = 'mail';/public \$mailer = 'smtp';/g" configuration.php
sed -i "s/public \$smtphost = 'localhost';/public \$smtphost = '${JOOMLA_SMTP_HOST}';/g" configuration.php
fi
# Update the SMTP port in configuration.php if JOOMLA_SMTP_HOST_PORT is set
if [[ -n "${JOOMLA_SMTP_HOST_PORT}" ]]; then
sed -i "s/public \$smtpport = 25;/public \$smtpport = ${JOOMLA_SMTP_HOST_PORT};/g" configuration.php
fi
# fix the ownership
if [ "$uid" = '0' ] && [ "$(stat -c '%u:%g' configuration.php)" != "$user:$group" ]; then
# Set configuration to correct owner
if ! chown -R "$user:$group" .; then
echo >&2
echo >&2 "Error: Ownership of configuration.php failed to be corrected."
fi
# Set configuration to correct permissions
if ! chmod 444 configuration.php; then
echo >&2
echo >&2 "Error: Permissions of configuration.php failed to be corrected."
fi
fi
################################################################################################################
echo >&2
echo >&2 "========================================================================"
else
echo >&2 "========================================================================"
echo >&2
echo >&2 "This server is now configured to run Joomla!"
echo >&2
echo >&2 "NOTE: You will need your database server address, database name,"
echo >&2 "and database user credentials to install Joomla."
echo >&2
echo >&2 "========================================================================"
if [ "$uid" = '0' ] && [ "$(stat -c '%u:%g' configuration.php)" != "$user:$group" ]; then
if ! chown -R "$user:$group" .; then
joomla_log_error "Ownership of configuration.php failed to be corrected."
fi
if ! chmod 444 configuration.php; then
joomla_log_error "Permissions of configuration.php failed to be corrected."
fi
fi
else
echo >&2 "========================================================================"
echo >&2
echo >&2 "This server is now configured to run Joomla!"
echo >&2
echo >&2 "NOTE: You will need your database server address, database name,"
echo >&2 "and database user credentials to install Joomla."
echo >&2
echo >&2 "========================================================================"
joomla_success_need_db
fi
else
joomla_success_need_db
fi
# end Joomla message block
joomla_line_end
fi
exec "$@"

View File

@ -17,8 +17,6 @@ We recommend using [Traefik](https://doc.traefik.io/traefik/) for reverse proxyi
Here's a basic Traefik configuration:
```yml
version: "3.3"
services:
traefik:
container_name: traefik
@ -51,7 +49,7 @@ services:
networks:
traefik:
external:
external: true
name: traefik_webgateway
```
@ -79,8 +77,6 @@ For Joomla setup, create a `docker-compose.yml` file in `/home/username/Docker/w
Example Joomla setup:
```yml
version: '3.3'
services:
mariadb_websitename:
image: mariadb:latest
@ -110,7 +106,7 @@ services:
JOOMLA_DB_USER: octoleo
JOOMLA_DB_NAME: octoleo
JOOMLA_DB_PASSWORD: your_password_here
JOOMLA_EXTENSIONS_URLS: https://git.vdm.dev/joomla/pkg-component-builder/archive/v5.0.0-rc6.zip
JOOMLA_EXTENSIONS_URLS: https://git.vdm.dev/joomla/pkg-component-builder/archive/5.x.zip
depends_on:
- mariadb_websitename
volumes:
@ -147,7 +143,7 @@ services:
networks:
traefik:
external:
external: true
name: traefik_webgateway
```